Index: res/res_features.c
===================================================================
--- res/res_features.c	(revision 181962)
+++ res/res_features.c	(working copy)
@@ -1179,6 +1179,13 @@ static int feature_exec_app(struct ast_channel *ch
 
 	ast_autoservice_start(idle);
 	
+        if(work && idle) {
+		pbx_builtin_setvar_helper(work, "DYNAMIC_PEERNAME", idle->name);
+		pbx_builtin_setvar_helper(idle, "DYNAMIC_PEERNAME", work->name);
+		pbx_builtin_setvar_helper(work, "DYNAMIC_FEATURENAME", feature->sname);
+		pbx_builtin_setvar_helper(idle, "DYNAMIC_FEATURENAME", feature->sname);
+	}
+
 	if (!ast_strlen_zero(feature->moh_class))
 		ast_moh_start(idle, feature->moh_class, NULL);
 
